#!/usr/bin/python
# -*- coding: utf-8 -*-
##############################################################################
# Project:     Perfil Educativo
# Module:     perfil.py
# Purpose:     Entorno grafico para Seleccionar un perfil y mostrar distintos escritorios.
# Language:    Python 2.5
# Date:        01-Jun-2012.
# Ver.:        01-Jun-2012.
# Author:    Isabel Aparicio Pérez
# Copyright:    2011 - Isabel Aparicio Pérez    <prog5pe@edu.juntaextremadura.net>
#
# This program is free software: you can redistribute it and/or modify
#it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
# 
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
# 
# You should have received a copy of the GNU General Public License
# along with this program.  If not, see <http://www.gnu.org/licenses/>.
# 
##############################################################################

import pygtk
import gtk
import subprocess
from subprocess import PIPE
import shutil
import os
import pwd
import sys
import pdb
import commands

class Base:

    def crear_ventana(self,titulo,X,Y):
        ##se encarga de crear una ventana con el titulo y el tamaño pasado por parametros
        self.ventana= gtk.Window(gtk.WINDOW_TOPLEVEL)
        self.ventana.set_position(gtk.WIN_POS_CENTER)
        self.ventana.set_size_request(X, Y)
        self.ventana.set_title(titulo) 
        self.ventana.show()
        return self.ventana
        
    def creaEtiqueta(self,texto,X,Y,alineacion,partido):
        ##se encarga de crear etiquetas con el texto que se le pasa por parametro
        ##el tamaño es X x Y
        ##se le pasa la alineacion y por ultimo un valor boleano que indicara si
        ##el texto se parte automaticamente o no
        self.etiqueta=gtk.Label(texto)
        self.etiqueta.set_size_request(X,Y)
        self.etiqueta.set_justify(alineacion)
        self.etiqueta.set_line_wrap(partido)
        self.etiqueta.show()
        return self.etiqueta
    
    
		
    def creaComboBox(self,perfiles):
	#crea el menu desplegable que va a mostrar los 9 perfiles seleccionables y por defecto
	#muestra el perfil general seleccionado.
        lista=gtk.ListStore('gchararray')
        self.combobox=gtk.ComboBox(lista)
        celda=gtk.CellRendererText()
        self.combobox.pack_start(celda,True)
        self.combobox.add_attribute(celda, 'text', 0)
        for n in perfiles:
            iterador=lista.append([n])        
        self.combobox.set_model(lista)
        self.combobox.set_active(8)
        self.combobox.show()
        return self.combobox
        
    
    def creaTabla(self,filas,columnas,homogeneo):
    #crea una tabla para empaquetar widgets del tamaño filas y columnas pasados como argumentos
        self.tabla=gtk.Table(filas,columnas,homogeneo)
        self.tabla.show()
        return self.tabla
        
        
    def creaFrame(self,titulo,estilo):
    #crea un marco con el titulo y el estilo pasados por parametros
        self.frame=gtk.AspectFrame(titulo,0.5,0.5,7.0,False)
        self.frame.show()
        return self.frame
       
        
    def creaCaja(self,vertical,homogeneo,espacio):
    #crea una caja vertical u horizontal dependiendo del valor pasado en el argumento Vertical
    #estas cajas las vamos a usar para colocar los widgets dentro de las ventanas.
        if vertical==True:
            self.box=gtk.VBox(homogeneo,espacio)
        else:
            self.box=gtk.HBox(homogeneo,espacio)
        self.box.show()
        return self.box
        
        
    def creaCajaBotones(self,horizontal,disposicion,espacio):
    #creamos una barra de botones horizontal o vertical dependiendo del valor del argumento horizontal
    #y ademas le pasamos el parametro disposicion que nos va a indicar el estilo de la barra de botones
        if horizontal==True:
            self.cajaboton=gtk.HButtonBox()
        else:
            self.cajaboton=gtk.VButtonBox()
        self.cajaboton.set_layout(disposicion)
        self.cajaboton.set_spacing(espacio)
        self.cajaboton.show()
        return self.cajaboton
        
    
    def creaBoton(self,nombre,stock,x,y):
    #crea un boton normal con el nombre y el stock predeterminado y ademas se les pasa tamaño para
    #redimensionar el boton 
        self.boton=gtk.Button(nombre,stock)
        self.boton.set_size_request(x,y)
        self.boton.show()
        return self.boton
        
    
    def copiaFichero(self,nombreusr,nombreconfig):
	#Obtiene el usuario que está logeado, copia el perfil elegido a 
	#/home/.../.config
	#Si existe ya el link aplicaciones.cfg, previamente lo borra.
		login=commands.getoutput("echo $LOGNAME")
		ruta=os.path.expanduser("~") + "/" + ".config/"
		rutausr=os.path.join("/usr/share/desktop-design-linexedu",nombreusr)
		shutil.copy(rutausr,ruta)
		os.chdir(ruta)
		os.rename(nombreusr,nombreconfig)
		if os.path.islink("aplicaciones.cfg"):
			os.remove("aplicaciones.cfg")
		os.symlink(nombreconfig,"aplicaciones.cfg")
                exit (0)
		return
	
    def creaperfil(self,widget,data):
		self.combobox=data[0]
		indice=self.combobox.get_active()
		ruta=os.path.expanduser("~") + "/" + ".config/"
		if not os.path.isdir(ruta):
			os.mkdir(ruta)
		if indice==0:
			self.copiaFichero("aplicaciones1Lengua.cfg","aplicaciones1")
                        exit(0)
		if indice==1:
			self.copiaFichero("aplicaciones2GeoHis.cfg","aplicaciones2")
                        exit(0)
		if indice==2:
			self.copiaFichero("aplicaciones3Mates.cfg","aplicaciones3")
                        exit(0)
		if indice==3:
			self.copiaFichero("aplicaciones4FQBG.cfg","aplicaciones4")
                        exit(0)
		if indice==4:
			self.copiaFichero("aplicaciones5Plas.cfg","aplicaciones5")
                        exit(0)
		if indice==5:
			self.copiaFichero("aplicaciones6Mus.cfg","aplicaciones6")
                        exit(0)
		if indice==6:
			self.copiaFichero("aplicaciones7EdFis.cfg","aplicaciones7")
                        exit(0)
		if indice==7:
			self.copiaFichero("aplicaciones8Tecno.cfg","aplicaciones8")
                        exit(0)
		if indice==8:
			self.copiaFichero("aplicaciones9Estudiante.cfg","aplicaciones9")
         		exit (0)
		return	
    
    def borradoevento(self,widget,data):
    ##pregunta antes de cerrar la ventana, si le decimos que no no cierra el dialogo
        ruta=os.path.expanduser("~") + "/" + ".config/"
        if not os.path.isdir(ruta):
			os.mkdir(ruta)    
        texto="   ¿Esta seguro de que desea cerrar la ventana sin seleccionar un perfil? " 
        dialogo=gtk.MessageDialog(self.ventana, gtk.DIALOG_MODAL,gtk.MESSAGE_INFO, gtk.BUTTONS_YES_NO,texto)
        dialogo.show() 
        respuesta = dialogo.run()
        dialogo.destroy()
        if respuesta == gtk.RESPONSE_YES:
            dialogo.destroy()
            self.ventana.destroy()
            self.copiaFichero("aplicaciones9Estudiante.cfg","aplicaciones9X")
            destruccion=False
        else:
            dialogo.destroy()
            destruccion=True
        return destruccion


    def destruir(self,widget,data):
    #cierra el programa
		#os.system("nohup /usr/bin/escritorio_educativo.py &")
		
		gtk.main_quit()
        
            
    def __init__(self):
	
		fichero=os.path.expanduser("~") + "/.config/aplicaciones.cfg"
		#print os.path.realpath(fichero)
		#print os.readlink(fichero)


		if os.path.isfile(fichero) and os.readlink(fichero)!="aplicaciones9X" : 
			print("El Fichero de Configuración existe, se sale sin realizar ningún cambio.")
			exit(0)
		ruta=os.path.expanduser("~") + "/" + ".config/"
		if not os.path.isdir(ruta):
			os.mkdir(ruta)
		padre=os.path.expanduser("~")
		rut=os.path.dirname(padre)
		print padre
		if rut=="/home/alumnos":
			self.copiaFichero("aplicaciones0Estudiante.cfg","aplicaciones0X")
			exit(0)
        #creamos la ventana principal
		self.ventanappal = self.crear_ventana("Elección de Perfil",600,250) 


		#creamos una caja y la ponemos en la ventan principal para añadir en esta caja
		#una etiqueta dentro de un frame
		#un combo
		#una barra de botones con la opcion de aceptar y cancelar		
		caja=self.creaCaja(True,True,20)
		self.ventanappal.add(caja)

        
        #creamos el marco y la etiqueta informativa y lo metemos en la caja
		marco=self.creaFrame("Informacion",gtk.SHADOW_IN) 
		texto="  Elija el perfil deseado, dependiendo del perfil elegido se mostraran distintas herramientas en los accesos directos. Si no elige ningun perfil entrara en el perfil por defecto."
		etiquetainformacion=self.creaEtiqueta(texto,500,200,gtk.JUSTIFY_LEFT,True)
		marco.add(etiquetainformacion)
		caja.pack_start(marco,False,False,0)
 
		#creamos el combo lo rellenamos y lo metemos en la caja
		perfiles=["1-Lengua, Literatura e Idiomas","2-Geografía e Historia ","3-Matemáticas","4-Fisica Química Biología Geología","5-Plástica","6-Música","7-Educación Física","8-Tecnología","9-Perfil General"]       
		comboperfil=self.creaComboBox(perfiles)  
		caja.pack_start(comboperfil,False,False,0)

        #creamos la barra de botones con el boton de aceptar y el de cancelar
		cajabotonesh=self.creaCajaBotones(True,gtk.BUTTONBOX_SPREAD,10)
		botonaceptar=self.creaBoton(None,gtk.STOCK_OK,30,30)
		cajabotonesh.add(botonaceptar)
		botoncancelar=self.creaBoton(None,gtk.STOCK_CANCEL,30,30)
		cajabotonesh.add(botoncancelar)
		caja.pack_start(cajabotonesh,False,False,0)
        
        #conectamos los eventos 
		self.ventanappal.connect("delete_event",self.borradoevento)
		self.ventanappal.connect("destroy",self.destruir,None)
		botonaceptar.connect("clicked",self.creaperfil,[comboperfil])
		botoncancelar.connect("clicked",self.borradoevento,None)

    def main(self):
        gtk.main()
        
        
if __name__ == "__main__":
    base = Base()
    base.main()
